      SUBROUTINE CMSET( NROW, ZCM)
C     CMSET SETS UP THE COMPLEX STRUCTURE MATRIX IN THE ARRAY ZCM
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      INCLUDE 'matpar.inc'
      INCLUDE 'zload.inc'
      INCLUDE 'segj.inc'
      INCLUDE 'dataj.inc'
      COMMON  /SMAT/ ZSSX(16,16)
      COMMON  /SCRATM/ ZD( 16)
      DIMENSION  ZCM( NROW,1)
      NPEQ= NP
      NEQ= N
      NOP= NEQ/ NPEQ
      IF(NOP.GT.16)GOTO 9910
C
C     CYCLE OVER MATRIX BLOCKS
C
      IT= NPBLK
      DO 13  IXBLK1=1, NBLOKS
      ISV=( IXBLK1-1)* NPBLK
      IF( IXBLK1.EQ. NBLOKS) IT= NLAST
      DO 1  I=1, NROW
      DO 1  J=1, IT
    1 ZCM( I, J)=(0.,0.)
      I1= ISV+1
      I2= ISV+ IT
      IN2= I2
      IF( IN2.GT. NP) IN2= NP
      IM1= I1- NP
      IM2= I2- NP
      IF( IM1.LT.1) IM1=1
      IST=1
      IF( I1.LE. NP) IST= NP- I1+2
C
C     WIRE SOURCE LOOP
C
      IF( N.EQ.0) GOTO 5
      DO 4  J=1, N
      CALL TRIO( J)
      IF(I1.LE.IN2)CALL CMWW(J,I1,IN2,ZCM,NROW,ZCM,NROW,1)
C
C     MATRIX ELEMENTS MODIFIED BY LOADING
C
      IF( NLOAD.EQ.0) GOTO 4
      IF( J.GT. NP) GOTO 4
      IPR= J- ISV
      IF( IPR.LT.1.OR. IPR.GT. IT) GOTO 4
      ZZAJ= ZARRAY( J)
      DO 3  I=1, JSNO
      JSS= JCO( I)
    3 ZCM( JSS, IPR)= ZCM( JSS, IPR)-( AX( I)+ CX( I))* ZZAJ
    4 CONTINUE


    5 IF( ICASE.EQ.1) GOTO 13
C     COMBINE ELEMENTS FOR SYMMETRY MODES
      DO 11  I=1, IT
      DO 11  J=1, NPEQ
      DO 8  K=1, NOP
      KA= J+( K-1)* NPEQ
    8 ZD( K)= ZCM( KA, I)
      ZDETER= ZD(1)
      DO 9  KK=2, NOP
    9 ZDETER= ZDETER+ ZD( KK)
      ZCM( J, I)= ZDETER
      DO 11  K=2, NOP
      KA= J+( K-1)* NPEQ
      ZDETER= ZD(1)
      DO 10  KK=2, NOP
   10 ZDETER= ZDETER+ ZD( KK)* ZSSX( K, KK)
      ZCM( KA, I)= ZDETER
   11 CONTINUE
   13 CONTINUE
      RETURN
 9910 WRITE(*,*)'TOO MANY SYMMETRY BLOCKS (max=16)'
      STOP
      END
