      SUBROUTINE EKSC(S,UZ,RH,XK,IJ,EZS,ERS,EZC,ERC,ZEZK,ERK)
C     COMPUTE E FIELD OF SINE, COSINE, AND CONSTANT CURRENT FILAMENTS BY
C     THIN WIRE APPROXIMATION.
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      COMPLEX*16  CON, GZ1, GZ2, GP1, GP2, GZP1, GZP2, EZS, ERS, EZC,
     &ERC, ERK
      COMMON  /TMI/ UZPK, RKB2, IJX
      DIMENSION  CONX(2)
      EQUIVALENCE(CONX,CON)
      DATA   CONX/0.,4.771341189D+0/
      IJX= IJ
      UZPK= XK* UZ
      RHK= XK* RH
      RKB2= RHK* RHK
      SH=.5* S
      SHK= XK* SH
      SS= SIN( SHK)
      CS= COS( SHK)
      RZ2= SH- UZ
      RZ1=-( SH+ UZ)
      CALL GX( RZ1, RH, XK, GZ1, GP1)
      CALL GX( RZ2, RH, XK, GZ2, GP2)
      GZP1= GP1* RZ1
      GZP2= GP2* RZ2
      EZS= CON*(( GZ2- GZ1)* CS* XK-( GZP2+ GZP1)* SS)
      EZC=- CON*(( GZ2+ GZ1)* SS* XK+( GZP2- GZP1)* CS)
      ERK= CON*( GP2- GP1)* RH
      CALL INTX(- SHK, SHK, RHK, IJ, CINT, SINT)
      ZEZK=- CON*( GZP2- GZP1+ XK* XK* CMPLX( CINT,- SINT))
      GZP1= GZP1* RZ1
      GZP2= GZP2* RZ2
      IF( RH.LT.1.D-10) GOTO 1
      ERS=- CON*(( GZP2+ GZP1+ GZ2+ GZ1)* SS-( RZ2* GZ2- RZ1* GZ1)* CS*
     &XK)/ RH
      ERC=- CON*(( GZP2- GZP1+ GZ2- GZ1)* CS+( RZ2* GZ2+ RZ1* GZ1)* SS*
     &XK)/ RH
      RETURN
    1 ERS=(0.,0.)
      ERC=(0.,0.)
      RETURN
      END
