      SUBROUTINE ETMNS(E)
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      INCLUDE 'vsorc.inc'
C     ETMNS FILLS THE ARRAY E WITH THE NEGATIVE OF THE ELECTRIC FIELD
C     INCIDENT ON THE STRUCTURE.  E IS THE RIGHT HAND SIDE OF THE MATRIX
C     EQUATION.
      COMPLEX*16  E
      COMMON  /ANGL/ SALP( NM)
      DIMENSION  CAB(1), SAB(1), E(NM)
      DIMENSION  T1X(1), T1Y(1), T1Z(1), T2X(1), T2Y(1), T2Z(1)
      EQUIVALENCE(CAB,ALP),(SAB,BET)
      EQUIVALENCE(T1X,SI),(T1Y,ALP),(T1Z,BET),(T2X,ICON1),(T2Y,ICON2),(
     &T2Z,ITAG)
      NQDS=0
C
C     APPLIED FIELD OF VOLTAGE SOURCES FOR TRANSMITTING CASE
      DO 1  I=1,N
    1 E( I)=(0.,0.)
      IF( NSANT.EQ.0) GOTO 3
      DO 2  I=1, NSANT
      IS= ISANT( I)
    2 E( IS)=- ZVSNT( I)/( SI( IS)* WLAM)
    3 IF( NVQD.EQ.0) RETURN
      DO 4  I=1, NVQD
      IS= IVQD( I)
    4 CALL QDSRC( IS, ZVQD( I), E)
      RETURN
      END
